#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<limits.h> //LONG_MAXを使うのに必要.
#include"SimpleImage.h" //画像クラス

//longが4byteか8byteによってBMPIO.hか、BMPIOlong8byte.hを使うか選択. OS依存だがたぶん、BMPIO.hの方を今後は使う.
#ifdef LONG_MAX
# if LONG_MAX == 2147483647
#include"BMPIO.h"
# else
#include"BMPIOlong8byte.h"
# endif
# endif
/* 次回から、#include<limits.h>は不要で、
#include"BMPIO.h"
又は、
#include"BMPIOlong8byte.h"
のみ使用.
 */

/* 
カラーBMP画像を読み込んで、第二引数のファイル名でカラーBMP画像として保存、第三引数のファイル名でグレースケール画像として保存するプログラム
コンパイル方法：make
実行方法(引数３)：./testBMP 入力カラーBMPファイル 出力カラーBMPファイル 出力グレースケール画像
実行例： ./testBMP lena.bmp lena_color.bmp lena_gray.bmp
 */
int main(int argc,char *argv[]){
  //BMPIOクラスのオブジェクトを作成.
  BMPIO *mybmp = new BMPIO();
  
  //画像クラスのオブジェクトを宣言.
  Image *R= NULL;
  Image *G= NULL;
  Image *B= NULL;
  Image *Gray=NULL;
  
  //画像サイズの変数.
  int sx,sy;
  
  //ファイル名を第一引数argv[1]で与えて画像サイズをsx,syに格納. BMPファイルが正常に開ければ、true開けなければfalseを返す.
  if(mybmp->readBMPSize(&sx,&sy,argv[1])){
    
    //取得した画像サイズでカラー用R,G,Bとグレースケール用Grayをメモリ確保.
    R = new Image(sx,sy);
    G = new Image(sx,sy);
    B = new Image(sx,sy);
    Gray = new Image(sx,sy);
    
    //BMPIOクラスを用いてカラー画像をR,G,Bへ入力.
    mybmp->readBMP(R,G,B,argv[1]);
    
    //画素を辿る二重ループ.
    int i,j;
    for(i=0;i<Gray->sy;i++)
      for(j=0;j<Gray->sx;j++){
	// R,G,Bの平均をグレースケールとして代入.
	Gray->img[i][j] = (R->img[i][j]+G->img[i][j]+B->img[i][j])/3.0;
      }
    //第二引数のファイル名でカラーBMP画像として保存.
    mybmp->saveBMP(R,G,B,argv[2]);
    //第三引数のファイル名でグレースケール画像として保存.
    mybmp->saveBMP(Gray,argv[3]);
    

  
  }
  //BMPIOクラスのオブジェクトをメモリ開放.
  delete mybmp;
  //NULLでなければ、カラー用R,G,Bとグレースケール用Grayをメモリ開放.
  //mybmp->readBMPSize()の戻り値がtrueならNULLでない:画像を正常に読み込めた.
  if(R!=NULL)delete R;
  if(G!=NULL)delete G;
  if(B!=NULL)delete B;
  if(Gray!=NULL)delete Gray;
  return 0;
}

